'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.default = undefined;

var _jsx = function () { var REACT_ELEMENT_TYPE = typeof Symbol === "function" && Symbol.for && Symbol.for("react.element") || 0xeac7; return function createRawReactElement(type, props, key, children) { var defaultProps = type && type.defaultProps; var childrenLength = arguments.length - 3; if (!props && childrenLength !== 0) { props = {}; } if (props && defaultProps) { for (var propName in defaultProps) { if (props[propName] === void 0) { props[propName] = defaultProps[propName]; } } } else if (!props) { props = defaultProps || {}; } if (childrenLength === 1) { props.children = children; } else if (childrenLength > 1) { var childArray = Array(childrenLength); for (var i = 0; i < childrenLength; i++) { childArray[i] = arguments[i + 3]; } props.children = childArray; } return { $$typeof: REACT_ELEMENT_TYPE, type: type, key: key === undefined ? null : '' + key, ref: null, props: props, _owner: null }; }; }();

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var FormGroup = function (_React$Component) {
	_inherits(FormGroup, _React$Component);

	function FormGroup() {
		var _ref;

		var _temp, _this, _ret;

		_classCallCheck(this, FormGroup);

		for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
			args[_key] = arguments[_key];
		}

		return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = FormGroup.__proto__ || Object.getPrototypeOf(FormGroup)).call.apply(_ref, [this].concat(args))), _this), _this.getTitleBlock = function () {
			var _this$props = _this.props,
			    displayName = _this$props.displayName,
			    name = _this$props.name,
			    component = _this$props.component,
			    required = _this$props.required;


			switch (component) {
				case "Checkbox":
					return null;
				case "Radio":
					return null;
			}

			var requiredStar = null;

			if (required) {
				requiredStar = '*';
			}

			var style = {
				padding: "0px",
				margin: "0px"
			};

			if (displayName !== undefined && displayName !== null && displayName !== '') {
				return _jsx('div', {}, void 0, _jsx('h5', {
					style: style
				}, void 0, displayName + ' ', _jsx('b', {
					style: { color: 'red' }
				}, void 0, requiredStar)));
			} else {
				return _jsx('div', {}, void 0, _jsx('h5', {
					style: style
				}, void 0, name + ' ', _jsx('b', {
					style: { color: 'red' }
				}, void 0, requiredStar)));
			}
		}, _this.getHelpBlock = function () {
			var help = _this.props.help;


			if (help) {
				return _jsx('div', {
					style: { color: "#757575" }
				}, void 0, _jsx('b', {}, void 0, help));
			}

			return null;
		}, _this.getAddonBeforeBlock = function () {
			var addonBefore = _this.props.addonBefore;


			if (addonBefore) {
				return _jsx('div', {
					className: 'col-md-3 pull-left',
					style: { textAlign: "left", marginTop: "15px", padding: "0px" }
				}, void 0, _jsx('p', {
					style: { margin: "0px" }
				}, void 0, addonBefore));
			}

			return null;
		}, _this.getAddonAfterBlock = function () {
			var addonAfter = _this.props.addonAfter;


			if (addonAfter) {
				return _jsx('div', {
					className: 'col-md-3 pull-right',
					style: { textAlign: "right", marginTop: "15px", padding: "0px" }
				}, void 0, _jsx('p', {
					style: { margin: "0px" }
				}, void 0, addonAfter));
			}

			return null;
		}, _this.getChildrenBlock = function () {
			var _this$props2 = _this.props,
			    children = _this$props2.children,
			    addonAfter = _this$props2.addonAfter,
			    addonBefore = _this$props2.addonBefore;


			if (addonAfter || addonBefore) {
				return _jsx('div', {
					className: 'col-md-9',
					style: { margin: "0px", padding: "0px" }
				}, void 0, children);
			}

			return children;
		}, _temp), _possibleConstructorReturn(_this, _ret);
	}

	_createClass(FormGroup, [{
		key: 'render',
		value: function render() {
			return _jsx('div', {
				style: { marginTop: "10px", marginBottom: "10px" }
			}, void 0, this.getTitleBlock(), _jsx('div', {}, void 0, this.getAddonBeforeBlock(), this.getChildrenBlock(), this.getAddonAfterBlock()), this.getHelpBlock());
		}
	}]);

	return FormGroup;
}(_react2.default.Component);

exports.default = FormGroup;
module.exports = exports['default'];