'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = undefined;

var _jsx = function () { var REACT_ELEMENT_TYPE = typeof Symbol === "function" && Symbol.for && Symbol.for("react.element") || 0xeac7; return function createRawReactElement(type, props, key, children) { var defaultProps = type && type.defaultProps; var childrenLength = arguments.length - 3; if (!props && childrenLength !== 0) { props = {}; } if (props && defaultProps) { for (var propName in defaultProps) { if (props[propName] === void 0) { props[propName] = defaultProps[propName]; } } } else if (!props) { props = defaultProps || {}; } if (childrenLength === 1) { props.children = children; } else if (childrenLength > 1) { var childArray = Array(childrenLength); for (var i = 0; i < childrenLength; i++) { childArray[i] = arguments[i + 3]; } props.children = childArray; } return { $$typeof: REACT_ELEMENT_TYPE, type: type, key: key === undefined ? null : '' + key, ref: null, props: props, _owner: null }; }; }();

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _Toolbar = require('material-ui/Toolbar/Toolbar');

var _Toolbar2 = _interopRequireDefault(_Toolbar);

var _ToolbarGroup = require('material-ui/Toolbar/ToolbarGroup');

var _ToolbarGroup2 = _interopRequireDefault(_ToolbarGroup);

var _ToolbarTitle = require('material-ui/Toolbar/ToolbarTitle');

var _ToolbarTitle2 = _interopRequireDefault(_ToolbarTitle);

var _RaisedButton = require('material-ui/RaisedButton/RaisedButton');

var _RaisedButton2 = _interopRequireDefault(_RaisedButton);

var _FormGroup = require('../common/FormGroup');

var _FormGroup2 = _interopRequireDefault(_FormGroup);

var _ArrayContainerItem = require('../common/ArrayContainerItem');

var _ArrayContainerItem2 = _interopRequireDefault(_ArrayContainerItem);

var _FieldPropTypes = require('../../util/FieldPropTypes');

var _FieldPropTypes2 = _interopRequireDefault(_FieldPropTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _ref2 = _jsx(_ToolbarGroup2.default, {
    firstChild: true
});

var ArrayContainer = function (_React$Component) {
    _inherits(ArrayContainer, _React$Component);

    function ArrayContainer() {
        var _ref;

        var _temp, _this, _ret;

        _classCallCheck(this, ArrayContainer);

        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
        }

        return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = ArrayContainer.__proto__ || Object.getPrototypeOf(ArrayContainer)).call.apply(_ref, [this].concat(args))), _this), _this.onClick = function () {
            var reduxFormProps = _this.props.reduxFormProps;

            reduxFormProps.addField({});
        }, _this.onAction = function (event, child, index) {
            var _this$props = _this.props,
                id = _this$props.id,
                value = _this$props.value,
                fields = _this$props.fields,
                onChange = _this$props.onChange,
                _this$props$reduxForm = _this$props.reduxFormProps,
                swapFields = _this$props$reduxForm.swapFields,
                removeField = _this$props$reduxForm.removeField;

            var key = child.key;

            switch (key) {
                case "remove":
                    removeField(index);
                    break;
                case "move_up":
                    if (index > 0) {
                        swapFields(index, index - 1);
                    }
                    break;
                case "move_down":
                    if (index < fields.length - 1) {
                        swapFields(index, index + 1);
                    }
                    break;
                case "move_first":
                    swapFields(index, 0);
                    break;
                case "move_last":
                    swapFields(index, fields.length - 1);
                    break;
            }

            if (onChange) {
                var values = {
                    id: id,
                    value: value
                };

                onChange(values);
            }
        }, _this.buildGroupComponent = function (field) {
            var _this$props2 = _this.props,
                componentFactory = _this$props2.componentFactory,
                layout = _this$props2.layout;


            return componentFactory.buildGroupComponent({
                component: layout.component,
                layout: layout,
                fields: field,
                componentFactory: componentFactory
            });
        }, _this.getComponents = function () {
            var fields = _this.props.fields;


            return fields.map(function (field, index) {
                return _jsx(_ArrayContainerItem2.default, {
                    index: index,
                    onAction: _this.onAction
                }, 'array-item-' + index + '-wrapper', _this.buildGroupComponent(field));
            });
        }, _this.getAddBar = function () {
            var addText = _this.props.addText;


            var text = addText ? addText : "Add";
            var components = _this.getComponents();

            if (components.length) {
                return _jsx(_Toolbar2.default, {}, void 0, _ref2, _jsx(_ToolbarGroup2.default, {
                    lastChild: true
                }, void 0, _jsx(_RaisedButton2.default, {
                    label: text,
                    onClick: _this.onClick,
                    primary: true
                })));
            }

            return null;
        }, _this.getAllComponents = function () {
            var components = _this.getComponents();

            var title = {
                fontSize: "14px",
                marginLeft: "10px"
            };

            if (components.length) {
                return components;
            } else {
                return _jsx(_Toolbar2.default, {}, void 0, _jsx(_ToolbarGroup2.default, {
                    firstChild: true
                }, void 0, _jsx(_ToolbarTitle2.default, {
                    text: 'This array is empty',
                    style: title
                })), _jsx(_ToolbarGroup2.default, {}, void 0, _jsx(_RaisedButton2.default, {
                    label: 'Add new Item',
                    onClick: _this.onClick,
                    primary: true
                })));
            }
        }, _temp), _possibleConstructorReturn(_this, _ret);
    }

    _createClass(ArrayContainer, [{
        key: 'render',
        value: function render() {
            var _props = this.props,
                displayName = _props.displayName,
                fieldLayout = _props.fieldLayout,
                innerSize = _props.innerSize,
                name = _props.name,
                addonAfter = _props.addonAfter,
                help = _props.help,
                addonBefore = _props.addonBefore,
                required = _props.required;


            var props = {
                displayName: displayName,
                name: name,
                fieldLayout: fieldLayout,
                innerSize: innerSize,
                addonAfter: addonAfter,
                addonBefore: addonBefore,
                help: help,
                required: required
            };

            return _react2.default.createElement(
                _FormGroup2.default,
                props,
                this.getAllComponents(),
                this.getAddBar()
            );
        }
    }]);

    return ArrayContainer;
}(_react2.default.Component);

exports.default = ArrayContainer;
module.exports = exports['default'];