'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.default = undefined;

var _jsx = function () { var REACT_ELEMENT_TYPE = typeof Symbol === "function" && Symbol.for && Symbol.for("react.element") || 0xeac7; return function createRawReactElement(type, props, key, children) { var defaultProps = type && type.defaultProps; var childrenLength = arguments.length - 3; if (!props && childrenLength !== 0) { props = {}; } if (props && defaultProps) { for (var propName in defaultProps) { if (props[propName] === void 0) { props[propName] = defaultProps[propName]; } } } else if (!props) { props = defaultProps || {}; } if (childrenLength === 1) { props.children = children; } else if (childrenLength > 1) { var childArray = Array(childrenLength); for (var i = 0; i < childrenLength; i++) { childArray[i] = arguments[i + 3]; } props.children = childArray; } return { $$typeof: REACT_ELEMENT_TYPE, type: type, key: key === undefined ? null : '' + key, ref: null, props: props, _owner: null }; }; }();

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reduxAutoformUtils = require('redux-autoform-utils');

var _DatePicker = require('material-ui/DatePicker/DatePicker');

var _DatePicker2 = _interopRequireDefault(_DatePicker);

var _TimePicker = require('material-ui/TimePicker/TimePicker');

var _TimePicker2 = _interopRequireDefault(_TimePicker);

var _FormGroup = require('../common/FormGroup');

var _FormGroup2 = _interopRequireDefault(_FormGroup);

var _FieldPropTypes = require('../../util/FieldPropTypes');

var _FieldPropTypes2 = _interopRequireDefault(_FieldPropTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var DateTimePicker = function (_React$Component) {
	_inherits(DateTimePicker, _React$Component);

	function DateTimePicker() {
		var _ref;

		var _temp, _this, _ret;

		_classCallCheck(this, DateTimePicker);

		for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
			args[_key] = arguments[_key];
		}

		return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = DateTimePicker.__proto__ || Object.getPrototypeOf(DateTimePicker)).call.apply(_ref, [this].concat(args))), _this), _this.getFormat = function (format, type, formats) {
			if (!type) {
				throw Error('\'type\' should be truthy');
			}

			if (!formats) {
				throw Error('\'localizer\' should be truthy');
			}

			if (format) {
				return format;
			}

			switch (type) {
				case 'datetime':
					return formats.default;
				case 'date':
					return formats.date;
				case 'time':
					return formats.time;
				default:
					throw new Error('Invalid type. Type: ' + type);
			}
		}, _this.onChange = function (event, date) {
			var onChange = _this.props.onChange;

			var dateString = _this.formatDate(date);

			onChange(dateString);
		}, _this.formatDate = function (date) {
			var _this$props = _this.props,
			    format = _this$props.format,
			    type = _this$props.type;

			var localizer = (0, _reduxAutoformUtils.getDateLocalizer)();

			format = _this.getFormat(format, type, localizer.formats);

			return localizer.format(date, format);
		}, _this.asDate = function (dateString) {
			var _this$props2 = _this.props,
			    format = _this$props2.format,
			    type = _this$props2.type;

			var localizer = (0, _reduxAutoformUtils.getDateLocalizer)();

			format = _this.getFormat(format, type, localizer.formats);

			return localizer.parse(dateString, format);
		}, _this.parseString = function () {
			var value = _this.props.value;


			if (typeof value === 'string') {
				return value !== '' ? _this.asDate(value) : null;
			} else {
				return value;
			}
		}, _temp), _possibleConstructorReturn(_this, _ret);
	}

	_createClass(DateTimePicker, [{
		key: 'render',
		value: function render() {
			var _props = this.props,
			    name = _props.name,
			    displayName = _props.displayName,
			    help = _props.help,
			    error = _props.error,
			    active = _props.active,
			    touched = _props.touched,
			    onBlur = _props.onBlur,
			    type = _props.type,
			    placeholder = _props.placeholder,
			    addonBefore = _props.addonBefore,
			    addonAfter = _props.addonAfter,
			    required = _props.required;

			var errors = touched || active ? error : null;

			var props = {
				displayName: displayName,
				name: name,
				help: help,
				addonBefore: addonBefore,
				addonAfter: addonAfter,
				required: required
			};

			switch (type) {
				case 'date':
					return _react2.default.createElement(
						_FormGroup2.default,
						props,
						_jsx(_DatePicker2.default, {
							name: name,
							value: this.parseString(),
							mode: 'landscape',
							container: 'inline',
							errorText: errors,
							hintText: placeholder,
							onChange: this.onChange,
							formatDate: this.formatDate,
							onBlur: onBlur,
							fullWidth: true,
							locale: 'en-US'
						})
					);

				case 'time':
					return _react2.default.createElement(
						_FormGroup2.default,
						props,
						_jsx(_TimePicker2.default, {
							format: '24hr',
							name: name,
							value: this.parseString(),
							errorText: errors,
							hintText: placeholder,
							onChange: this.onChange,
							onBlur: onBlur,
							fullWidth: true
						})
					);

				default:
					return false;
			}
		}
	}]);

	return DateTimePicker;
}(_react2.default.Component);

exports.default = DateTimePicker;
module.exports = exports['default'];