'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _FormGroup = require('../common/FormGroup');

var _FormGroup2 = _interopRequireDefault(_FormGroup);

var _FieldPropTypes = require('../../util/FieldPropTypes');

var _FieldPropTypes2 = _interopRequireDefault(_FieldPropTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var FieldGroup = function (_React$Component) {
    _inherits(FieldGroup, _React$Component);

    function FieldGroup() {
        var _ref;

        var _temp, _this, _ret;

        _classCallCheck(this, FieldGroup);

        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
        }

        return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = FieldGroup.__proto__ || Object.getPrototypeOf(FieldGroup)).call.apply(_ref, [this].concat(args))), _this), _this.getGroupContent = function () {
            var _this$props = _this.props,
                componentFactory = _this$props.componentFactory,
                _this$props$_extra = _this$props._extra,
                layout = _this$props$_extra.layout,
                fields = _this$props$_extra.fields,
                groupName = _this$props.group;

            var group = layout.groups.find(function (g) {
                return g.name == groupName;
            });
            var groupProps = {
                component: group.component,
                layout: group,
                fields: fields,
                componentFactory: componentFactory
            };

            if (!group) {
                throw Error('Could not find group. Group: ' + groupName);
            }

            return componentFactory.buildGroupComponent(groupProps);
        }, _temp), _possibleConstructorReturn(_this, _ret);
    }

    _createClass(FieldGroup, [{
        key: 'render',
        value: function render() {
            var _props = this.props,
                required = _props.required,
                name = _props.name,
                displayName = _props.displayName,
                help = _props.help,
                addonAfter = _props.addonAfter,
                addonBefore = _props.addonBefore;


            var props = {
                displayName: displayName,
                name: name,
                help: help,
                addonAfter: addonAfter,
                addonBefore: addonBefore,
                required: required
            };

            return _react2.default.createElement(
                _FormGroup2.default,
                props,
                this.getGroupContent()
            );
        }
    }]);

    return FieldGroup;
}(_react2.default.Component);

exports.default = FieldGroup;
module.exports = exports['default'];