'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.default = undefined;

var _jsx = function () { var REACT_ELEMENT_TYPE = typeof Symbol === "function" && Symbol.for && Symbol.for("react.element") || 0xeac7; return function createRawReactElement(type, props, key, children) { var defaultProps = type && type.defaultProps; var childrenLength = arguments.length - 3; if (!props && childrenLength !== 0) { props = {}; } if (props && defaultProps) { for (var propName in defaultProps) { if (props[propName] === void 0) { props[propName] = defaultProps[propName]; } } } else if (!props) { props = defaultProps || {}; } if (childrenLength === 1) { props.children = children; } else if (childrenLength > 1) { var childArray = Array(childrenLength); for (var i = 0; i < childrenLength; i++) { childArray[i] = arguments[i + 3]; } props.children = childArray; } return { $$typeof: REACT_ELEMENT_TYPE, type: type, key: key === undefined ? null : '' + key, ref: null, props: props, _owner: null }; }; }();

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _RaisedButton = require('material-ui/RaisedButton/RaisedButton');

var _RaisedButton2 = _interopRequireDefault(_RaisedButton);

var _DropZone = require('../common/DropZone');

var _DropZone2 = _interopRequireDefault(_DropZone);

var _FileInfo = require('../common/FileInfo');

var _FileInfo2 = _interopRequireDefault(_FileInfo);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _ref3 = _jsx('b', {}, void 0, 'Attachment');

var FileUpload = function (_React$Component) {
	_inherits(FileUpload, _React$Component);

	function FileUpload() {
		var _ref;

		var _temp, _this, _ret;

		_classCallCheck(this, FileUpload);

		for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
			args[_key] = arguments[_key];
		}

		return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = FileUpload.__proto__ || Object.getPrototypeOf(FileUpload)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
			files: [],
			disableUpload: true,
			status: null,
			message: null,
			alertVisible: false
		}, _this.onDrop = function (files) {
			//TODO filter to avoid duplicates
			var fileArray = [].concat(_toConsumableArray(files), _toConsumableArray(_this.state.files));

			_this.syncFields(fileArray);
			_this.setState({ files: fileArray, disableUpload: false });
		}, _this.onClick = function () {
			// TODO Handle response status for upload service
			var files = _this.state.files;
			var url = _this.props.url;


			var fileData = new FormData();

			files.forEach(function (file) {
				fileData.append("fileData", file);
			});

			fetch(url, {
				method: "POST",
				body: fileData
			}).then(function (response) {
				return response.json();
			}).then(function (_ref2) {
				var status = _ref2.status,
				    message = _ref2.message;
				return _this.setState({
					status: status,
					message: message,
					alertVisible: true
				});
			});

			setTimeout(function () {
				return _this.dismissAlert();
			}, 4000);
		}, _this.dismissAlert = function () {
			_this.setState({ alertVisible: false });
		}, _this.deleteItem = function (position) {
			var files = _this.state.files;

			files.splice(position, 1);

			_this.syncFields(files);
			_this.setState({ files: files, disableUpload: files.length == 0 });
		}, _this.syncFields = function (files) {
			var onChange = _this.props.onChange;


			var fileNames = files.map(function (file) {
				return file.name;
			});

			onChange(fileNames);
		}, _this.openDropZone = function () {
			if (_this.refs) {
				_this.refs.dropzone.open();
			}
		}, _temp), _possibleConstructorReturn(_this, _ret);
	}

	_createClass(FileUpload, [{
		key: 'render',
		value: function render() {
			var _this2 = this;

			var _state = this.state,
			    files = _state.files,
			    disableUpload = _state.disableUpload;


			var attachmentStyle = {
				marginTop: "6px",
				color: "#616161"
			};

			var messageContainerStyle = {
				marginTop: "10px"
			};

			var messageStyle = {
				textAlign: "center",
				color: "#616161"
			};

			var rowStyle = {
				padding: "0px"
			};

			if (files) {
				rowStyle = {
					padding: "15px"
				};
			}

			return _jsx('div', {}, void 0, _jsx('div', {
				className: 'row'
			}, void 0, _jsx('div', {
				className: 'col-md-2'
			}, void 0, _jsx('div', {
				style: attachmentStyle
			}, void 0, _ref3)), _jsx('div', {
				className: 'col-md-10'
			}, void 0, _react2.default.createElement(
				_DropZone2.default,
				{ ref: 'dropzone', onDrop: this.onDrop, disableClick: true },
				_jsx('div', {
					style: messageContainerStyle
				}, void 0, _jsx('p', {
					style: messageStyle
				}, void 0, 'Drop files to attach, or ', _jsx('a', {
					onClick: this.openDropZone
				}, void 0, 'browse'))),
				_jsx('div', {
					style: rowStyle
				}, void 0, _jsx('div', {
					className: 'row'
				}, void 0, files.map(function (file, index) {
					return _jsx(_FileInfo2.default, {
						file: file,
						onClick: function onClick() {
							return _this2.deleteItem(index);
						}
					}, index);
				})))
			))), _jsx('div', {
				className: 'col-md-12'
			}, void 0, _jsx(_RaisedButton2.default, {
				disabled: disableUpload,
				type: 'submit',
				label: 'Upload',
				onClick: this.onClick,
				primary: true
			})));
		}
	}]);

	return FileUpload;
}(_react2.default.Component);

exports.default = FileUpload;
module.exports = exports['default'];