'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = undefined;

var _jsx = function () { var REACT_ELEMENT_TYPE = typeof Symbol === "function" && Symbol.for && Symbol.for("react.element") || 0xeac7; return function createRawReactElement(type, props, key, children) { var defaultProps = type && type.defaultProps; var childrenLength = arguments.length - 3; if (!props && childrenLength !== 0) { props = {}; } if (props && defaultProps) { for (var propName in defaultProps) { if (props[propName] === void 0) { props[propName] = defaultProps[propName]; } } } else if (!props) { props = defaultProps || {}; } if (childrenLength === 1) { props.children = children; } else if (childrenLength > 1) { var childArray = Array(childrenLength); for (var i = 0; i < childrenLength; i++) { childArray[i] = arguments[i + 3]; } props.children = childArray; } return { $$typeof: REACT_ELEMENT_TYPE, type: type, key: key === undefined ? null : '' + key, ref: null, props: props, _owner: null }; }; }();

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _AutoComplete = require('material-ui/AutoComplete/AutoComplete');

var _AutoComplete2 = _interopRequireDefault(_AutoComplete);

var _FetchUtils = require('../../util/FetchUtils');

var _FetchUtils2 = _interopRequireDefault(_FetchUtils);

var _FormGroup = require('../common/FormGroup');

var _FormGroup2 = _interopRequireDefault(_FormGroup);

var _FieldPropTypes = require('../../util/FieldPropTypes');

var _FieldPropTypes2 = _interopRequireDefault(_FieldPropTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Lookup = function (_React$Component) {
    _inherits(Lookup, _React$Component);

    function Lookup() {
        var _ref;

        var _temp, _this, _ret;

        _classCallCheck(this, Lookup);

        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
        }

        return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Lookup.__proto__ || Object.getPrototypeOf(Lookup)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
            dataSource: [],
            inputValue: ''
        }, _this.performNetworkSearch = function (url) {
            var inputValue = _this.state.inputValue;


            if (inputValue && inputValue !== '') {
                var searchUrl = url + inputValue;

                (0, _FetchUtils2.default)(searchUrl).then(function (response) {
                    return response.json();
                }).then(function (json) {
                    return _this.fillDataSourceFromRemote(json);
                }).catch(function (err) {
                    return _this.showErrorInConsole(err);
                });
            }
        }, _this.showErrorInConsole = function (err) {
            console.error('There was an when fetching resources. The error was => ' + err);
        }, _this.fillDataSource = function (arr) {
            var label = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'label';
            var value = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 'value';

            var newDataSource = arr.map(function (item) {
                return {
                    text: item[label],
                    value: item[value]
                };
            });

            _this.setState({
                dataSource: newDataSource
            });
        }, _this.fillDataSourceFromLocal = function () {
            var options = _this.props.options;


            if (Array.isArray(options)) {
                _this.fillDataSource(options);
            }
        }, _this.fillDataSourceFromRemote = function (json) {
            var options = _this.props.options;
            var valueKey = options.valueKey,
                labelKey = options.labelKey,
                arrayKey = options.arrayKey;


            if (Array.isArray(json)) {
                _this.fillDataSource(json, labelKey, valueKey);
            } else {
                _this.fillDataSource(json[arrayKey], labelKey, valueKey);
            }
        }, _this.onUpdateInput = function (searchText) {
            var url = _this.props.options.url;

            var newState = {
                inputValue: searchText
            };

            if (url) {
                _this.setState(newState, function () {
                    return _this.performNetworkSearch(url);
                });
            } else {
                _this.setState(newState, function () {
                    return _this.fillDataSourceFromLocal();
                });
            }
        }, _this.onNewRequest = function (text) {
            var onChange = _this.props.onChange;


            onChange(text);
        }, _temp), _possibleConstructorReturn(_this, _ret);
    }

    _createClass(Lookup, [{
        key: 'componentWillMount',
        value: function componentWillMount() {
            this.fillDataSourceFromLocal();
        }
    }, {
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
            //Reset state when this component is unmounted
            this.setState({
                dataSource: [],
                inputValue: ''
            });
        }
    }, {
        key: 'render',
        value: function render() {
            var _props = this.props,
                required = _props.required,
                displayName = _props.displayName,
                name = _props.name,
                addonAfter = _props.addonAfter,
                addonBefore = _props.addonBefore,
                placeholder = _props.placeholder,
                error = _props.error,
                touched = _props.touched,
                active = _props.active,
                help = _props.help,
                onBlur = _props.onBlur;

            var errors = touched || active ? error : null;
            var dataSource = this.state.dataSource;


            var props = {
                displayName: displayName,
                name: name,
                help: help,
                addonAfter: addonAfter,
                addonBefore: addonBefore,
                required: required
            };

            return _react2.default.createElement(
                _FormGroup2.default,
                props,
                _jsx(_AutoComplete2.default, {
                    filter: _AutoComplete2.default.caseInsensitiveFilter,
                    errorText: errors,
                    dataSource: dataSource,
                    hintText: placeholder,
                    onNewRequest: this.onNewRequest,
                    onUpdateInput: this.onUpdateInput,
                    onBlur: onBlur,
                    fullWidth: true,
                    animated: true,
                    openOnFocus: true
                })
            );
        }
    }]);

    return Lookup;
}(_react2.default.Component);

exports.default = Lookup;
module.exports = exports['default'];