'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = undefined;

var _jsx = function () { var REACT_ELEMENT_TYPE = typeof Symbol === "function" && Symbol.for && Symbol.for("react.element") || 0xeac7; return function createRawReactElement(type, props, key, children) { var defaultProps = type && type.defaultProps; var childrenLength = arguments.length - 3; if (!props && childrenLength !== 0) { props = {}; } if (props && defaultProps) { for (var propName in defaultProps) { if (props[propName] === void 0) { props[propName] = defaultProps[propName]; } } } else if (!props) { props = defaultProps || {}; } if (childrenLength === 1) { props.children = children; } else if (childrenLength > 1) { var childArray = Array(childrenLength); for (var i = 0; i < childrenLength; i++) { childArray[i] = arguments[i + 3]; } props.children = childArray; } return { $$typeof: REACT_ELEMENT_TYPE, type: type, key: key === undefined ? null : '' + key, ref: null, props: props, _owner: null }; }; }();

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _MenuItem = require('material-ui/MenuItem/MenuItem');

var _MenuItem2 = _interopRequireDefault(_MenuItem);

var _SelectField = require('material-ui/SelectField/SelectField');

var _SelectField2 = _interopRequireDefault(_SelectField);

var _FetchUtils = require('../../util/FetchUtils');

var _FetchUtils2 = _interopRequireDefault(_FetchUtils);

var _FormGroup = require('../common/FormGroup');

var _FormGroup2 = _interopRequireDefault(_FormGroup);

var _FieldPropTypes = require('../../util/FieldPropTypes');

var _FieldPropTypes2 = _interopRequireDefault(_FieldPropTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Select = function (_React$Component) {
    _inherits(Select, _React$Component);

    function Select() {
        var _ref;

        var _temp, _this, _ret;

        _classCallCheck(this, Select);

        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
        }

        return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Select.__proto__ || Object.getPrototypeOf(Select)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
            value: {},
            urlOptions: [],
            urlErrors: null
        }, _this.onChange = function (event, index, value) {
            var onChange = _this.props.onChange;


            onChange(value);
            _this.setState({ value: value });
        }, _this.getItems = function () {
            var options = _this.props.options;
            var url = options.url,
                labelKey = options.labelKey,
                valueKey = options.valueKey;
            var _this$state = _this.state,
                urlOptions = _this$state.urlOptions,
                urlErrors = _this$state.urlErrors;


            if (Array.isArray(options)) {
                return _this.renderItems(options);
            } else if (url && labelKey && valueKey) {
                if (Array.isArray(urlOptions)) {
                    return _this.renderItems(urlOptions, valueKey, labelKey);
                } else if (urlErrors) {
                    console.error('Select - There was the following error when fetching from resource =>\n                    ' + JSON.stringify(urlErrors, null, 2));
                }
            }
        }, _this.renderItems = function (arr) {
            var value = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'value';
            var text = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 'text';

            return arr.map(function (item, index) {
                return _jsx(_MenuItem2.default, {
                    value: item[value],
                    primaryText: item[text]
                }, 'select-item-' + index + '-wrapper');
            });
        }, _temp), _possibleConstructorReturn(_this, _ret);
    }

    //TODO evaluate if options.url come and array comes too


    _createClass(Select, [{
        key: 'componentWillMount',
        value: function componentWillMount() {
            var _this2 = this;

            var options = this.props.options;
            var url = options.url;


            if (url) {
                (0, _FetchUtils2.default)(url).then(function (response) {
                    return response.json();
                }).then(function (response) {
                    return _this2.setState({ urlOptions: response });
                });
            }
        }
    }, {
        key: 'render',
        value: function render() {
            var _props = this.props,
                addonBefore = _props.addonBefore,
                addonAfter = _props.addonAfter,
                displayName = _props.displayName,
                name = _props.name,
                placeholder = _props.placeholder,
                error = _props.error,
                touched = _props.touched,
                active = _props.active,
                help = _props.help,
                onBlur = _props.onBlur,
                required = _props.required;

            var errors = touched || active ? error : null;
            var value = this.state.value;


            var props = {
                displayName: displayName,
                name: name,
                help: help,
                addonBefore: addonBefore,
                addonAfter: addonAfter,
                required: required
            };

            return _react2.default.createElement(
                _FormGroup2.default,
                props,
                _jsx(_SelectField2.default, {
                    errorText: errors,
                    value: value,
                    hintText: placeholder,
                    onChange: this.onChange,
                    onBlur: onBlur,
                    fullWidth: true
                }, void 0, this.getItems())
            );
        }
    }]);

    return Select;
}(_react2.default.Component);

exports.default = Select;
module.exports = exports['default'];