'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _jsx = function () { var REACT_ELEMENT_TYPE = typeof Symbol === "function" && Symbol.for && Symbol.for("react.element") || 0xeac7; return function createRawReactElement(type, props, key, children) { var defaultProps = type && type.defaultProps; var childrenLength = arguments.length - 3; if (!props && childrenLength !== 0) { props = {}; } if (props && defaultProps) { for (var propName in defaultProps) { if (props[propName] === void 0) { props[propName] = defaultProps[propName]; } } } else if (!props) { props = defaultProps || {}; } if (childrenLength === 1) { props.children = children; } else if (childrenLength > 1) { var childArray = Array(childrenLength); for (var i = 0; i < childrenLength; i++) { childArray[i] = arguments[i + 3]; } props.children = childArray; } return { $$typeof: REACT_ELEMENT_TYPE, type: type, key: key === undefined ? null : '' + key, ref: null, props: props, _owner: null }; }; }();

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _temp2;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _LinearProgress = require('material-ui/LinearProgress/LinearProgress');

var _LinearProgress2 = _interopRequireDefault(_LinearProgress);

var _BaseGroup2 = require('./BaseGroup');

var _BaseGroup3 = _interopRequireDefault(_BaseGroup2);

var _Arrays = require('../../util/Arrays');

var _Arrays2 = _interopRequireDefault(_Arrays);

var _GroupPropTypes = require('../../util/GroupPropTypes');

var _GroupPropTypes2 = _interopRequireDefault(_GroupPropTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var QuestionnaireGroup = (_temp2 = _class = function (_BaseGroup) {
    _inherits(QuestionnaireGroup, _BaseGroup);

    function QuestionnaireGroup() {
        var _ref;

        var _temp, _this, _ret;

        _classCallCheck(this, QuestionnaireGroup);

        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
        }

        return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = QuestionnaireGroup.__proto__ || Object.getPrototypeOf(QuestionnaireGroup)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
            percentage: 0
        }, _this.filterValues = function (fields) {
            var arr = _Arrays2.default.mergeJson(fields.map(function (field) {
                var _field$reduxFormProps = field.reduxFormProps,
                    value = _field$reduxFormProps.value,
                    name = _field$reduxFormProps.name;

                return value && value !== '' ? _defineProperty({}, name, value) : null;
            }));

            return Object.keys(arr);
        }, _this.calculatePercentage = function (fields) {
            var length = _this.props.fields.length;

            var filteredValues = _this.filterValues(fields);

            _this.setState({
                percentage: filteredValues.length * 100 / length
            });
        }, _temp), _possibleConstructorReturn(_this, _ret);
    }

    _createClass(QuestionnaireGroup, [{
        key: 'componentDidMount',
        value: function componentDidMount() {
            var fields = this.props.fields;


            this.calculatePercentage(fields);
        }
    }, {
        key: 'componentWillReceiveProps',
        value: function componentWillReceiveProps(nextProps) {
            if (!Object.is(nextProps, this.props)) {
                var fields = nextProps.fields;


                this.calculatePercentage(fields);
            }
        }
    }, {
        key: 'render',
        value: function render() {
            var percentage = this.state.percentage;


            return _jsx('section', {}, void 0, _jsx('div', {
                className: 'row'
            }, void 0, _jsx('div', {
                className: 'container-fluid',
                style: { marginTop: "10px" }
            }, void 0, _jsx('h5', {}, void 0, 'The currently progress is ' + percentage + ' %'), _jsx(_LinearProgress2.default, {
                value: percentage,
                min: 0,
                max: 100,
                mode: 'determinate',
                style: { height: "10px" }
            })), _jsx('div', {
                className: 'metaform-group'
            }, void 0, _jsx('div', {
                className: 'col-md-12',
                style: { marginTop: "10px" }
            }, void 0, this.getHeader()), _jsx('div', {
                className: 'metaform-group-content'
            }, void 0, this.getContent()))));
        }
    }]);

    return QuestionnaireGroup;
}(_BaseGroup3.default), _class.propTypes = _extends({}, _GroupPropTypes2.default, {
    component: _propTypes2.default.string,
    fields: _propTypes2.default.array.isRequired,
    layout: _propTypes2.default.object.isRequired,
    componentFactory: _propTypes2.default.object.isRequired
}), _temp2);
exports.default = QuestionnaireGroup;
module.exports = exports['default'];