'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.default = undefined;

var _jsx = function () { var REACT_ELEMENT_TYPE = typeof Symbol === "function" && Symbol.for && Symbol.for("react.element") || 0xeac7; return function createRawReactElement(type, props, key, children) { var defaultProps = type && type.defaultProps; var childrenLength = arguments.length - 3; if (!props && childrenLength !== 0) { props = {}; } if (props && defaultProps) { for (var propName in defaultProps) { if (props[propName] === void 0) { props[propName] = defaultProps[propName]; } } } else if (!props) { props = defaultProps || {}; } if (childrenLength === 1) { props.children = children; } else if (childrenLength > 1) { var childArray = Array(childrenLength); for (var i = 0; i < childrenLength; i++) { childArray[i] = arguments[i + 3]; } props.children = childArray; } return { $$typeof: REACT_ELEMENT_TYPE, type: type, key: key === undefined ? null : '' + key, ref: null, props: props, _owner: null }; }; }();

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _temp2;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _Tab = require('material-ui/Tabs/Tab');

var _Tab2 = _interopRequireDefault(_Tab);

var _Tabs = require('material-ui/Tabs/Tabs');

var _Tabs2 = _interopRequireDefault(_Tabs);

var _BaseGroup2 = require('./BaseGroup');

var _BaseGroup3 = _interopRequireDefault(_BaseGroup2);

var _Arrays = require('../../util/Arrays');

var _Arrays2 = _interopRequireDefault(_Arrays);

var _GroupPropTypes = require('../../util/GroupPropTypes');

var _GroupPropTypes2 = _interopRequireDefault(_GroupPropTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var TabGroup = (_temp2 = _class = function (_BaseGroup) {
	_inherits(TabGroup, _BaseGroup);

	function TabGroup() {
		var _ref;

		var _temp, _this, _ret;

		_classCallCheck(this, TabGroup);

		for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
			args[_key] = arguments[_key];
		}

		return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = TabGroup.__proto__ || Object.getPrototypeOf(TabGroup)).call.apply(_ref, [this].concat(args))), _this), _this.tabsContext = {
			fields: []
		}, _this.state = {
			position: 0,
			fieldsMap: []
		}, _this.getComponents = function () {
			var _this$props = _this.props,
			    layout = _this$props.layout,
			    componentFactory = _this$props.componentFactory,
			    fields = _this$props.fields;

			var components = void 0;

			if (layout.fields) {

				components = layout.fields.map(function (field) {
					var fieldMetadata = fields.find(function (cp) {
						return cp.name === field.name;
					});

					if (!fieldMetadata) {
						throw Error('Could not find field. Field: ' + field.name);
					}

					// in case the field is going to render layouts internally, it's going to need information about the
					// layout and field. I'm not sure if this is the best way to do it, probably not. TODO: Review it.
					fieldMetadata._extra = { layout: layout, fields: fields };

					return {
						data: fieldMetadata,
						length: layout.fields.length,
						component: componentFactory.buildFieldComponent(fieldMetadata)
					};
				});
			} else if (layout.groups) {
				components = layout.groups.map(function (group) {
					group = _extends({}, group, { headLess: true });

					return {
						data: group,
						length: layout.groups.length,
						component: componentFactory.buildGroupComponent({
							component: group.component,
							layout: group,
							fields: fields,
							componentFactory: componentFactory
						})
					};
				});
			}

			return components;
		}, _this.onTabSelected = function (position) {
			_this.setState({ position: position });
		}, _this.updateTabContext = function (_ref2) {
			var fields = _ref2.fields;

			// Reads each field value of autoform and creates an object fieldName => error.
			_this.tabsContext.fields = Object.keys(_Arrays2.default.mergeJson(fields.map(function (field) {
				if (field.reduxFormProps.touched) {
					return field.reduxFormProps.error ? _defineProperty({}, field.name, field.reduxFormProps.error) : null;
				}

				return null;
			})));
		}, _this.getAllTabs = function (groups) {
			return groups.map(function (group, index) {
				return _this.getTabMap(group, index);
			});
		}, _this.getTabMap = function (group, idx) {
			var data = null;

			if (group.groups) {
				data = group.groups.map(function (g) {
					return _this.getTabMap(g, idx);
				});
			} else if (group.fields) {
				data = group.fields;
			}

			return _defineProperty({}, idx, data);
		}, _this.getFieldsByTabArray2 = function () {
			var layout = _this.props.layout;


			var tabMap = _this.getAllTabs(layout.groups);

			tabMap.forEach(function (tabNum, index) {
				tabNum[index] = tabNum[index].map(function (field) {
					if (Array.isArray(field[index])) {
						return _Arrays2.default.mergeJson(field[index].map(function (f) {
							return f.name;
						}));
					}

					return field.name;
				});
			});

			console.info('This is TabMap -> ' + JSON.stringify(tabMap, null, 2));
			return _Arrays2.default.mergeJson(tabMap);
		}, _this.getStyle = function (position) {
			var fieldsMap = _this.state.fieldsMap;

			var style = {};

			if (fieldsMap.length == 0) return style;

			var fieldsByTab = fieldsMap[position];

			var hasErrors = _Arrays2.default.intersect(fieldsByTab, _this.tabsContext.fields).size > 0;

			if (hasErrors) style = { backgroundColor: "red" };

			console.info(JSON.stringify(style));

			return style;
		}, _temp), _possibleConstructorReturn(_this, _ret);
	}

	_createClass(TabGroup, [{
		key: 'componentDidMount',
		value: function componentDidMount() {
			this.setState({
				fieldsMap: this.getFieldsByTabArray2()
			});

			this.updateTabContext(this.props);
		}
	}, {
		key: 'componentWillReceiveProps',
		value: function componentWillReceiveProps(nextProps) {
			if (!Object.is(this.props, nextProps)) {
				this.updateTabContext(nextProps);
			}
		}
	}, {
		key: 'render',
		value: function render() {
			var _this2 = this;

			var layout = this.props.layout;
			var position = this.state.position;

			var content = this.getContent();

			return _jsx('section', {}, void 0, _jsx('div', {
				className: 'container-fluid'
			}, void 0, _jsx('div', {
				className: 'row'
			}, void 0, _jsx('div', {
				className: 'metaform-group'
			}, void 0, _jsx(_Tabs2.default, {
				initialSelectedIndex: position,
				onChange: this.onTabSelected
			}, void 0, layout.groups.map(function (_ref5, position) {
				var title = _ref5.title;
				return _jsx(_Tab2.default, {
					label: title,
					value: position,
					style: _this2.getStyle(position)
				}, position);
			})), _jsx('div', {
				className: 'metaform-group-content'
			}, void 0, content[position])))));
		}
	}]);

	return TabGroup;
}(_BaseGroup3.default), _class.propTypes = _GroupPropTypes2.default, _temp2);
exports.default = TabGroup;
module.exports = exports['default'];