'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = undefined;

var _jsx = function () { var REACT_ELEMENT_TYPE = typeof Symbol === "function" && Symbol.for && Symbol.for("react.element") || 0xeac7; return function createRawReactElement(type, props, key, children) { var defaultProps = type && type.defaultProps; var childrenLength = arguments.length - 3; if (!props && childrenLength !== 0) { props = {}; } if (props && defaultProps) { for (var propName in defaultProps) { if (props[propName] === void 0) { props[propName] = defaultProps[propName]; } } } else if (!props) { props = defaultProps || {}; } if (childrenLength === 1) { props.children = children; } else if (childrenLength > 1) { var childArray = Array(childrenLength); for (var i = 0; i < childrenLength; i++) { childArray[i] = arguments[i + 3]; } props.children = childArray; } return { $$typeof: REACT_ELEMENT_TYPE, type: type, key: key === undefined ? null : '' + key, ref: null, props: props, _owner: null }; }; }();

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _temp2;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _Toolbar = require('material-ui/Toolbar/Toolbar');

var _Toolbar2 = _interopRequireDefault(_Toolbar);

var _ToolbarGroup = require('material-ui/Toolbar/ToolbarGroup');

var _ToolbarGroup2 = _interopRequireDefault(_ToolbarGroup);

var _RaisedButton = require('material-ui/RaisedButton/RaisedButton');

var _RaisedButton2 = _interopRequireDefault(_RaisedButton);

var _BaseGroup2 = require('./BaseGroup');

var _BaseGroup3 = _interopRequireDefault(_BaseGroup2);

var _Arrays = require('../../util/Arrays');

var _Arrays2 = _interopRequireDefault(_Arrays);

var _GroupPropTypes = require('../../util/GroupPropTypes');

var _GroupPropTypes2 = _interopRequireDefault(_GroupPropTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _ref3 = _jsx(_ToolbarGroup2.default, {
    firstChild: true
});

var WizardGroup = (_temp2 = _class = function (_BaseGroup) {
    _inherits(WizardGroup, _BaseGroup);

    function WizardGroup() {
        var _ref;

        var _temp, _this, _ret;

        _classCallCheck(this, WizardGroup);

        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
        }

        return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = WizardGroup.__proto__ || Object.getPrototypeOf(WizardGroup)).call.apply(_ref, [this].concat(args))), _this), _this.wizardContext = {
            fields: {},
            goToStep: function goToStep(stepName) {
                return _this.toStep(stepName);
            },
            goToPosition: function goToPosition(position) {
                return _this.toPosition(position);
            },
            next: function next() {
                return _this.nextStep();
            }
        }, _this.state = {
            position: 0,
            totalSteps: _this.props.layout.groups.length - 1,
            stepFlow: []
        }, _this.toStep = function (stepName) {
            var steps = _this.getSteps();
            var foundStep = steps.find(function (step) {
                return step.name === stepName;
            });

            if (foundStep) {
                _this.trackStepFlow(foundStep.position);
                _this.setState({ position: foundStep.position });
            } else {
                console.error('Step ' + stepName + ' does not exists');
            }
        }, _this.toPosition = function (position) {
            var totalSteps = _this.state.totalSteps;


            if (position >= 0 && position <= totalSteps) {
                _this.trackStepFlow(position);
                _this.setState({ position: position });
            } else {
                console.error('Position ' + position + ' does not exists');
            }
        }, _this.trackStepFlow = function (position) {
            var stepFlow = _this.state.stepFlow;


            stepFlow.push({
                originalPosition: _this.state.position,
                position: position
            });

            _this.setState({ stepFlow: stepFlow });

            console.log(JSON.stringify(stepFlow));
        }, _this.backToFlow = function () {
            var stepFlow = _this.state.stepFlow;

            var flowOnBack = stepFlow.pop();

            _this.setState({
                stepFlow: stepFlow,
                position: flowOnBack.originalPosition
            });
        }, _this.isFlowInMyPosition = function () {
            var _this$state = _this.state,
                stepFlow = _this$state.stepFlow,
                position = _this$state.position;
            var length = stepFlow.length;

            if (length > 0) return stepFlow[length - 1].position == position;

            return false;
        }, _this.nextStep = function () {
            var position = _this.state.position;


            _this.setState({ position: position + 1 });
        }, _this.backStep = function () {
            var position = _this.state.position;


            _this.setState({ position: position - 1 });
        }, _this.updateWizardContext = function () {
            var fields = _this.props.fields;

            // Reads each field value of autoform and creates an object fieldName => fieldValue.

            _this.wizardContext.fields = _Arrays2.default.mergeJson(fields.map(function (field) {
                return _defineProperty({}, field.name, field.reduxFormProps.value);
            }));
        }, _this.getButtonSection = function (steps) {
            var _this$state2 = _this.state,
                position = _this$state2.position,
                totalSteps = _this$state2.totalSteps;
            var transition = steps[position].transition;


            var nextButton = null;
            var backButton = null;

            if (position != 0) {
                backButton = _jsx(_RaisedButton2.default, {
                    label: 'Back',
                    onClick: _this.isFlowInMyPosition() ? _this.backToFlow : _this.backStep,
                    primary: true
                });
            }

            if (position != totalSteps) {
                nextButton = _jsx(_RaisedButton2.default, {
                    label: 'Next',
                    onClick: transition ? function () {
                        return transition(_this.wizardContext);
                    } : _this.nextStep,
                    primary: true
                });
            }

            return _jsx('div', {
                className: 'row'
            }, void 0, _jsx('div', {
                className: 'col-md-12'
            }, void 0, _jsx(_Toolbar2.default, {
                style: { backgroundColor: "#ffffff" }
            }, void 0, _ref3, _jsx(_ToolbarGroup2.default, {
                lastChild: true
            }, void 0, backButton, nextButton))));
        }, _this.getSteps = function () {
            var layout = _this.props.layout;

            var content = _this.getContent();

            // Maps each content to his transition function
            // Each step has associated a name and a position.
            return layout.groups.map(function (group, index) {
                return {
                    content: content[index],
                    transition: group.transition,
                    name: group.name,
                    position: index
                };
            });
        }, _temp), _possibleConstructorReturn(_this, _ret);
    }

    // Expose functions to the user in order to make the transitions, and the field values of the form


    // Saves an object containing the step position that started the flow and the position after that flow


    // Get the last flow and set the step position to the step that initiated the flow to the current step position.


    // Checks if the current step is the last step in stepFlow, if that's the case it returns true.


    _createClass(WizardGroup, [{
        key: 'render',
        value: function render() {
            var position = this.state.position;

            var steps = this.getSteps();
            var buttonSection = this.getButtonSection(steps);

            this.updateWizardContext();

            return _jsx('section', {}, void 0, _jsx('div', {
                className: 'row'
            }, void 0, _jsx('div', {
                className: 'metaform-group'
            }, void 0, steps[position].content)), buttonSection);
        }
    }]);

    return WizardGroup;
}(_BaseGroup3.default), _class.propTypes = _GroupPropTypes2.default, _temp2);
exports.default = WizardGroup;
module.exports = exports['default'];