'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = undefined;

var _jsx = function () { var REACT_ELEMENT_TYPE = typeof Symbol === "function" && Symbol.for && Symbol.for("react.element") || 0xeac7; return function createRawReactElement(type, props, key, children) { var defaultProps = type && type.defaultProps; var childrenLength = arguments.length - 3; if (!props && childrenLength !== 0) { props = {}; } if (props && defaultProps) { for (var propName in defaultProps) { if (props[propName] === void 0) { props[propName] = defaultProps[propName]; } } } else if (!props) { props = defaultProps || {}; } if (childrenLength === 1) { props.children = children; } else if (childrenLength > 1) { var childArray = Array(childrenLength); for (var i = 0; i < childrenLength; i++) { childArray[i] = arguments[i + 3]; } props.children = childArray; } return { $$typeof: REACT_ELEMENT_TYPE, type: type, key: key === undefined ? null : '' + key, ref: null, props: props, _owner: null }; }; }();

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _temp2;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _Tab = require('material-ui/Tabs/Tab');

var _Tab2 = _interopRequireDefault(_Tab);

var _Tabs = require('material-ui/Tabs/Tabs');

var _Tabs2 = _interopRequireDefault(_Tabs);

var _Toolbar = require('material-ui/Toolbar/Toolbar');

var _Toolbar2 = _interopRequireDefault(_Toolbar);

var _ToolbarGroup = require('material-ui/Toolbar/ToolbarGroup');

var _ToolbarGroup2 = _interopRequireDefault(_ToolbarGroup);

var _RaisedButton = require('material-ui/RaisedButton/RaisedButton');

var _RaisedButton2 = _interopRequireDefault(_RaisedButton);

var _BaseGroup2 = require('./BaseGroup');

var _BaseGroup3 = _interopRequireDefault(_BaseGroup2);

var _GroupPropTypes = require('../../util/GroupPropTypes');

var _GroupPropTypes2 = _interopRequireDefault(_GroupPropTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _ref2 = _jsx(_ToolbarGroup2.default, {
    firstChild: true
});

var WizardTabGroup = (_temp2 = _class = function (_BaseGroup) {
    _inherits(WizardTabGroup, _BaseGroup);

    function WizardTabGroup() {
        var _ref;

        var _temp, _this, _ret;

        _classCallCheck(this, WizardTabGroup);

        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
        }

        return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = WizardTabGroup.__proto__ || Object.getPrototypeOf(WizardTabGroup)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
            totalSteps: _this.props.layout.groups.length - 1,
            position: 0
        }, _this.getComponents = function () {
            var _this$props = _this.props,
                layout = _this$props.layout,
                componentFactory = _this$props.componentFactory,
                fields = _this$props.fields;

            var components = void 0;

            if (layout.fields) {

                components = layout.fields.map(function (field) {
                    var fieldMetadata = fields.find(function (cp) {
                        return cp.name === field.name;
                    });

                    if (!fieldMetadata) {
                        throw Error('Could not find field. Field: ' + field.name);
                    }

                    // in case the field is going to render layouts internally, it's going to need information about the
                    // layout and field. I'm not sure if this is the best way to do it, probably not. TODO: Review it.
                    fieldMetadata._extra = { layout: layout, fields: fields };

                    return {
                        data: fieldMetadata,
                        length: layout.fields.length,
                        component: componentFactory.buildFieldComponent(fieldMetadata)
                    };
                });
            } else if (layout.groups) {
                components = layout.groups.map(function (group) {
                    group = _extends({}, group, { headLess: true });

                    return {
                        data: group,
                        length: layout.groups.length,
                        component: componentFactory.buildGroupComponent({
                            component: group.component,
                            layout: group,
                            fields: fields,
                            componentFactory: componentFactory
                        })
                    };
                });
            }

            return components;
        }, _this.nextStep = function () {
            var position = _this.state.position;


            _this.setState({ position: position + 1 });
            _this.onTabSelected(position + 1);
        }, _this.backStep = function () {
            var position = _this.state.position;


            _this.setState({ position: position - 1 });
            _this.onTabSelected(position - 1);
        }, _this.getButtonSection = function () {
            var _this$state = _this.state,
                position = _this$state.position,
                totalSteps = _this$state.totalSteps;


            var nextButton = null;
            var backButton = null;

            if (position != 0) {
                backButton = _jsx(_RaisedButton2.default, {
                    label: 'Back',
                    onClick: _this.backStep,
                    primary: true
                });
            }

            if (position != totalSteps) {
                nextButton = _jsx(_RaisedButton2.default, {
                    label: 'Next',
                    onClick: _this.nextStep,
                    primary: true
                });
            }

            return _jsx('div', {
                className: 'row'
            }, void 0, _jsx('div', {
                className: 'col-md-12'
            }, void 0, _jsx(_Toolbar2.default, {
                style: { backgroundColor: "#ffffff" }
            }, void 0, _ref2, _jsx(_ToolbarGroup2.default, {
                lastChild: true
            }, void 0, backButton, nextButton))));
        }, _this.onTabSelected = function (position) {
            _this.setState({ position: position });
        }, _temp), _possibleConstructorReturn(_this, _ret);
    }

    _createClass(WizardTabGroup, [{
        key: 'render',
        value: function render() {
            var layout = this.props.layout;
            var position = this.state.position;

            var content = this.getContent();
            var buttonSection = this.getButtonSection();

            return _jsx('section', {}, void 0, _jsx('div', {
                className: 'container-fluid'
            }, void 0, _jsx('div', {
                className: 'row'
            }, void 0, _jsx('div', {
                className: 'metaform-group'
            }, void 0, _jsx(_Tabs2.default, {
                initialSelectedIndex: position,
                value: position,
                onChange: this.onTabSelected
            }, void 0, layout.groups.map(function (_ref3, index) {
                var title = _ref3.title;
                return _jsx(_Tab2.default, {
                    label: title,
                    value: index
                }, index);
            })), _jsx('div', {
                className: 'metaform-group-content'
            }, void 0, content[position])), buttonSection)));
        }
    }]);

    return WizardTabGroup;
}(_BaseGroup3.default), _class.propTypes = _GroupPropTypes2.default, _temp2);
exports.default = WizardTabGroup;
module.exports = exports['default'];